#include "Form1.frm"
#include "FileIO.ch"

/*
 * Evento OnShow.
 */
METHOD Form1OnShow( oSender ) CLASS TForm1

   Request DbfCdx

   if !File( "Fotos.dbf" )
      DbCreate( "Fotos.dbf", { { "Nombre",  "C", 256, 0 }, ;
                               { "Datos",   "M",  10, 0 } }, "DbfCdx", .T., "Fotos" )
      Fotos->( DbCloseArea() )
   endif

   DbUseArea( .T., "DbfCdx", "Fotos.dbf", "Fotos", .F., .F. )

return

/*
 * Evento OnClose.
 */
METHOD Form1OnClose( oSender, nAction ) CLASS TForm1

   Fotos->( DbCloseArea() )

return


/*
 * Evento OnClick.
 */
METHOD Button1OnClick( oSender ) CLASS TForm1

   local nHandle, cBuffer, nRead, nTotal, cData

   if !::OpenDialog1:Execute()
      return
   endif

   nHandle := FOpen( ::OpenDialog1:FileName, FO_READ )
   
   if nHandle >= 0
      cBuffer := Space( 4096 )
      cData := ""
      nRead := FRead( nHandle, @cBuffer, 4096 )
      nTotal := nRead
      
      do while nRead > 0
         cData += Left( cBuffer, nRead )
         nRead := FRead( nHandle, @cBuffer, 4096 )
         nTotal += nRead
      enddo

      FClose( nHandle )
      Fotos->( DbAppend() )
      Fotos->Nombre := ExtractFileName( ::OpenDialog1:FileName ) + ExtractFileExt( ::OpenDialog1:FileName )
      Fotos->Datos := cData
      ::DbGrid1:Refresh()
   endif

return

/*
 * Evento OnDblClick.
 */
METHOD DbGrid1OnDblClick( oSender ) CLASS TForm1

   local cTempFileName, nSize, nHandle, cData, cExt
   
   if !Fotos->( Eof() )
      GetTempPath( 0, @cTempFileName )
      GetTempFileName( cTempFileName, "tmp", 0, @cTempFileName )
      nHandle := FOpen( cTempFileName, FO_READWRITE )

      if nHandle >= 0
         cData := Fotos->Datos
         nSize := Len( cData )

         do while nSize > 4096
            FWrite( nHandle, Left( cData, 4096 ), 4096 )
            cData := SubStr( cData, 4097 )
            nSize -= 4096
         enddo

         FWrite( nHandle, cData, nSize )
         FClose( nHandle )
         cExt := Upper( ExtractFileExt( Fotos->Nombre ) )

         do case
            case cExt == ".BMP"
               ::Image1:Picture:Bitmap:FileName := cTempFileName
               ::Image1:Stretch := ::Image1:Picture:Bitmap:Width > ::Image1:Width .or. ;
                                   ::Image1:Picture:Bitmap:Height > ::Image1:Height

            case cExt == ".ICO"
               ::Image1:Picture:Icon:FileName := cTempFileName
               ::Image1:Stretch := ::Image1:Picture:Icon:Width > ::Image1:Width .or. ;
                                   ::Image1:Picture:Icon:Height > ::Image1:Height

            case cExt == ".JPG"
               ::Image1:Picture:JPeg:FileName := cTempFileName
               ::Image1:Stretch := ::Image1:Picture:JPeg:Width > ::Image1:Width .or. ;
                                   ::Image1:Picture:JPeg:Height > ::Image1:Height

            case cExt == ".JPEG"
               ::Image1:Picture:JPeg:FileName := cTempFileName
               ::Image1:Stretch := ::Image1:Picture:JPeg:Width > ::Image1:Width .or. ;
                                   ::Image1:Picture:JPeg:Height > ::Image1:Height

            case cExt == ".GIF"
               ::Image1:Picture:Gif:FileName := cTempFileName
               ::Image1:Stretch := ::Image1:Picture:Gif:Width > ::Image1:Width .or. ;
                                   ::Image1:Picture:Gif:Height > ::Image1:Height
         endcase
      endif

      FErase( cTempFileName )
   endif

return